﻿// ALL LEXERS AND THEIR INDEX
// BELOW YOU CAN FIND THE STYLE INDICES FOR EACH LEXER

public enum Lexer
{    
	container = 0,
	@null = 1,
	python = 2,
	cpp = 3,
	html = 4,
	xml = 5,
	perl = 6,
	sql = 7,
	vb = 8,
	properties = 9,
	errorlist = 10,
	makefile = 11,
	batch = 12,
	xcode = 13,
	latex = 14,
	lua = 15,
	diff = 16,
	conf = 17,
	pascal = 18,
	ave = 19,
	ada = 20,
	lisp = 21,
	ruby = 22,
	eiffel = 23,
	eiffelkw = 24,
	tcl = 25,
	nncrontab = 26,
	bullant = 27,
	vbscript = 28,
	asp = 29,
	php = 30,
	baan = 31,
	matlab = 32,
	scriptol = 33,
	asm = 34,
	cppnocase = 35,
	fortran = 36,
	f77 = 37,
	css = 38,
	pov = 39,
	lout = 40,
	escript = 41,
	ps = 42,
	nsis = 43,
	mmixal = 44,
	clw = 45,
	clwnocase = 46,
	lot = 47,
	yaml = 48,
	tex = 49,
	metapost = 50,
	powerbasic = 51,
	forth = 52,
	erlang = 53,
	octave = 54,
	mssql = 55,
	verilog = 56,
	kix = 57,
	gui4cli = 58,
	specman = 59,
	au3 = 60,
	apdl = 61,
	bash = 62,
	automatic = 1000
}



// STYLE INDICES FOR EACH LEXER

public enum Python
{    
	@default = 0,
	commentline = 1,
	number = 2,
	@string = 3,
	character = 4,
	word = 5,
	triple = 6,
	tripledouble = 7,
	classname = 8,
	defname = 9,
	@operator = 10,
	identifier = 11,
	commentblock = 12,
	stringeol = 13,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum Ruby
{    
	@default = 0,
	commentline = 1,
	number = 2,
	@string = 3,
	character = 4,
	word = 5,
	triple = 6,
	tripledouble = 7,
	classname = 8,
	defname = 9,
	@operator = 10,
	identifier = 11,
	commentblock = 12,
	stringeol = 13,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum Cpp
{    
	@default = 0,
	comment = 1,
	commentline = 2,
	commentdoc = 3,
	number = 4,
	word = 5,
	@string = 6,
	character = 7,
	uuid = 8,
	preprocessor = 9,
	@operator = 10,
	identifier = 11,
	stringeol = 12,
	verbatim = 13,
	regex = 14,
	commentlinedoc = 15,
	word2 = 16,
	commentdockeyword = 17,
	commentdockeyworderror = 18,
	globalclass = 19,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum SQL
{    
	@default = 0,
	comment = 1,
	commentline = 2,
	commentdoc = 3,
	number = 4,
	word = 5,
	@string = 6,
	character = 7,
	uuid = 8,
	preprocessor = 9,
	@operator = 10,
	identifier = 11,
	stringeol = 12,
	verbatim = 13,
	regex = 14,
	commentlinedoc = 15,
	word2 = 16,
	commentdockeyword = 17,
	commentdockeyworderror = 18,
	globalclass = 19,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum Pascal
{    
	@default = 0,
	comment = 1,
	commentline = 2,
	commentdoc = 3,
	number = 4,
	word = 5,
	@string = 6,
	character = 7,
	uuid = 8,
	preprocessor = 9,
	@operator = 10,
	identifier = 11,
	stringeol = 12,
	verbatim = 13,
	regex = 14,
	commentlinedoc = 15,
	word2 = 16,
	commentdockeyword = 17,
	commentdockeyworderror = 18,
	globalclass = 19,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum TCL
{    
	@default = 0,
	comment = 1,
	commentline = 2,
	commentdoc = 3,
	number = 4,
	word = 5,
	@string = 6,
	character = 7,
	uuid = 8,
	preprocessor = 9,
	@operator = 10,
	identifier = 11,
	stringeol = 12,
	verbatim = 13,
	regex = 14,
	commentlinedoc = 15,
	word2 = 16,
	commentdockeyword = 17,
	commentdockeyworderror = 18,
	globalclass = 19,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum BullAnt
{    
	@default = 0,
	comment = 1,
	commentline = 2,
	commentdoc = 3,
	number = 4,
	word = 5,
	@string = 6,
	character = 7,
	uuid = 8,
	preprocessor = 9,
	@operator = 10,
	identifier = 11,
	stringeol = 12,
	verbatim = 13,
	regex = 14,
	commentlinedoc = 15,
	word2 = 16,
	commentdockeyword = 17,
	commentdockeyworderror = 18,
	globalclass = 19,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum HTML
{    
	@default = 0,
	tag = 1,
	tagunknown = 2,
	attribute = 3,
	attributeunknown = 4,
	number = 5,
	doublestring = 6,
	singlestring = 7,
	other = 8,
	comment = 9,
	entity = 10,
	tagend = 11,
	xmlstart = 12,
	xmlend = 13,
	script = 14,
	asp = 15,
	aspat = 16,
	cdata = 17,
	question = 18,
	@value = 19,
	xccomment = 20,
	sgml_default = 21,
	sgml_command = 22,
	sgml_1st_param = 23,
	sgml_doublestring = 24,
	sgml_simplestring = 25,
	sgml_error = 26,
	sgml_special = 27,
	sgml_entity = 28,
	sgml_comment = 29,
	sgml_1st_param_comment = 30,
	sgml_block_default = 31,
	j_start = 40,
	j_default = 41,
	j_comment = 42,
	j_commentline = 43,
	j_commentdoc = 44,
	j_number = 45,
	j_word = 46,
	j_keyword = 47,
	j_doublestring = 48,
	j_singlestring = 49,
	j_symbols = 50,
	j_stringeol = 51,
	j_regex = 52,
	ja_start = 55,
	ja_default = 56,
	ja_comment = 57,
	ja_commentline = 58,
	ja_commentdoc = 59,
	ja_number = 60,
	ja_word = 61,
	ja_keyword = 62,
	ja_doublestring = 63,
	ja_singlestring = 64,
	ja_symbols = 65,
	ja_stringeol = 66,
	ja_regex = 67,
	b_start = 70,
	b_default = 71,
	b_commentline = 72,
	b_number = 73,
	b_word = 74,
	b_string = 75,
	b_identifier = 76,
	b_stringeol = 77,
	ba_start = 80,
	ba_default = 81,
	ba_commentline = 82,
	ba_number = 83,
	ba_word = 84,
	ba_string = 85,
	ba_identifier = 86,
	ba_stringeol = 87,
	p_start = 90,
	p_default = 91,
	p_commentline = 92,
	p_number = 93,
	p_string = 94,
	p_character = 95,
	p_word = 96,
	p_triple = 97,
	p_tripledouble = 98,
	p_classname = 99,
	p_defname = 100,
	p_operator = 101,
	p_identifier = 102,
	php_complex_variable = 104,
	pa_start = 105,
	pa_default = 106,
	pa_commentline = 107,
	pa_number = 108,
	pa_string = 109,
	pa_character = 110,
	pa_word = 111,
	pa_triple = 112,
	pa_tripledouble = 113,
	pa_classname = 114,
	pa_defname = 115,
	pa_operator = 116,
	pa_identifier = 117,
	php_default = 118,
	php_hstring = 119,
	php_simplestring = 120,
	php_word = 121,
	php_number = 122,
	php_variable = 123,
	php_comment = 124,
	php_commentline = 125,
	php_hstring_variable = 126,
	php_operator = 127,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum XML
{    
	@default = 0,
	tag = 1,
	tagunknown = 2,
	attribute = 3,
	attributeunknown = 4,
	number = 5,
	doublestring = 6,
	singlestring = 7,
	other = 8,
	comment = 9,
	entity = 10,
	tagend = 11,
	xmlstart = 12,
	xmlend = 13,
	script = 14,
	asp = 15,
	aspat = 16,
	cdata = 17,
	question = 18,
	@value = 19,
	xccomment = 20,
	sgml_default = 21,
	sgml_command = 22,
	sgml_1st_param = 23,
	sgml_doublestring = 24,
	sgml_simplestring = 25,
	sgml_error = 26,
	sgml_special = 27,
	sgml_entity = 28,
	sgml_comment = 29,
	sgml_1st_param_comment = 30,
	sgml_block_default = 31,
	j_start = 40,
	j_default = 41,
	j_comment = 42,
	j_commentline = 43,
	j_commentdoc = 44,
	j_number = 45,
	j_word = 46,
	j_keyword = 47,
	j_doublestring = 48,
	j_singlestring = 49,
	j_symbols = 50,
	j_stringeol = 51,
	j_regex = 52,
	ja_start = 55,
	ja_default = 56,
	ja_comment = 57,
	ja_commentline = 58,
	ja_commentdoc = 59,
	ja_number = 60,
	ja_word = 61,
	ja_keyword = 62,
	ja_doublestring = 63,
	ja_singlestring = 64,
	ja_symbols = 65,
	ja_stringeol = 66,
	ja_regex = 67,
	b_start = 70,
	b_default = 71,
	b_commentline = 72,
	b_number = 73,
	b_word = 74,
	b_string = 75,
	b_identifier = 76,
	b_stringeol = 77,
	ba_start = 80,
	ba_default = 81,
	ba_commentline = 82,
	ba_number = 83,
	ba_word = 84,
	ba_string = 85,
	ba_identifier = 86,
	ba_stringeol = 87,
	p_start = 90,
	p_default = 91,
	p_commentline = 92,
	p_number = 93,
	p_string = 94,
	p_character = 95,
	p_word = 96,
	p_triple = 97,
	p_tripledouble = 98,
	p_classname = 99,
	p_defname = 100,
	p_operator = 101,
	p_identifier = 102,
	php_complex_variable = 104,
	pa_start = 105,
	pa_default = 106,
	pa_commentline = 107,
	pa_number = 108,
	pa_string = 109,
	pa_character = 110,
	pa_word = 111,
	pa_triple = 112,
	pa_tripledouble = 113,
	pa_classname = 114,
	pa_defname = 115,
	pa_operator = 116,
	pa_identifier = 117,
	php_default = 118,
	php_hstring = 119,
	php_simplestring = 120,
	php_word = 121,
	php_number = 122,
	php_variable = 123,
	php_comment = 124,
	php_commentline = 125,
	php_hstring_variable = 126,
	php_operator = 127,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum ASP
{    
	@default = 0,
	tag = 1,
	tagunknown = 2,
	attribute = 3,
	attributeunknown = 4,
	number = 5,
	doublestring = 6,
	singlestring = 7,
	other = 8,
	comment = 9,
	entity = 10,
	tagend = 11,
	xmlstart = 12,
	xmlend = 13,
	script = 14,
	asp = 15,
	aspat = 16,
	cdata = 17,
	question = 18,
	@value = 19,
	xccomment = 20,
	sgml_default = 21,
	sgml_command = 22,
	sgml_1st_param = 23,
	sgml_doublestring = 24,
	sgml_simplestring = 25,
	sgml_error = 26,
	sgml_special = 27,
	sgml_entity = 28,
	sgml_comment = 29,
	sgml_1st_param_comment = 30,
	sgml_block_default = 31,
	j_start = 40,
	j_default = 41,
	j_comment = 42,
	j_commentline = 43,
	j_commentdoc = 44,
	j_number = 45,
	j_word = 46,
	j_keyword = 47,
	j_doublestring = 48,
	j_singlestring = 49,
	j_symbols = 50,
	j_stringeol = 51,
	j_regex = 52,
	ja_start = 55,
	ja_default = 56,
	ja_comment = 57,
	ja_commentline = 58,
	ja_commentdoc = 59,
	ja_number = 60,
	ja_word = 61,
	ja_keyword = 62,
	ja_doublestring = 63,
	ja_singlestring = 64,
	ja_symbols = 65,
	ja_stringeol = 66,
	ja_regex = 67,
	b_start = 70,
	b_default = 71,
	b_commentline = 72,
	b_number = 73,
	b_word = 74,
	b_string = 75,
	b_identifier = 76,
	b_stringeol = 77,
	ba_start = 80,
	ba_default = 81,
	ba_commentline = 82,
	ba_number = 83,
	ba_word = 84,
	ba_string = 85,
	ba_identifier = 86,
	ba_stringeol = 87,
	p_start = 90,
	p_default = 91,
	p_commentline = 92,
	p_number = 93,
	p_string = 94,
	p_character = 95,
	p_word = 96,
	p_triple = 97,
	p_tripledouble = 98,
	p_classname = 99,
	p_defname = 100,
	p_operator = 101,
	p_identifier = 102,
	php_complex_variable = 104,
	pa_start = 105,
	pa_default = 106,
	pa_commentline = 107,
	pa_number = 108,
	pa_string = 109,
	pa_character = 110,
	pa_word = 111,
	pa_triple = 112,
	pa_tripledouble = 113,
	pa_classname = 114,
	pa_defname = 115,
	pa_operator = 116,
	pa_identifier = 117,
	php_default = 118,
	php_hstring = 119,
	php_simplestring = 120,
	php_word = 121,
	php_number = 122,
	php_variable = 123,
	php_comment = 124,
	php_commentline = 125,
	php_hstring_variable = 126,
	php_operator = 127,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum PHP
{    
	@default = 0,
	tag = 1,
	tagunknown = 2,
	attribute = 3,
	attributeunknown = 4,
	number = 5,
	doublestring = 6,
	singlestring = 7,
	other = 8,
	comment = 9,
	entity = 10,
	tagend = 11,
	xmlstart = 12,
	xmlend = 13,
	script = 14,
	asp = 15,
	aspat = 16,
	cdata = 17,
	question = 18,
	@value = 19,
	xccomment = 20,
	sgml_default = 21,
	sgml_command = 22,
	sgml_1st_param = 23,
	sgml_doublestring = 24,
	sgml_simplestring = 25,
	sgml_error = 26,
	sgml_special = 27,
	sgml_entity = 28,
	sgml_comment = 29,
	sgml_1st_param_comment = 30,
	sgml_block_default = 31,
	j_start = 40,
	j_default = 41,
	j_comment = 42,
	j_commentline = 43,
	j_commentdoc = 44,
	j_number = 45,
	j_word = 46,
	j_keyword = 47,
	j_doublestring = 48,
	j_singlestring = 49,
	j_symbols = 50,
	j_stringeol = 51,
	j_regex = 52,
	ja_start = 55,
	ja_default = 56,
	ja_comment = 57,
	ja_commentline = 58,
	ja_commentdoc = 59,
	ja_number = 60,
	ja_word = 61,
	ja_keyword = 62,
	ja_doublestring = 63,
	ja_singlestring = 64,
	ja_symbols = 65,
	ja_stringeol = 66,
	ja_regex = 67,
	b_start = 70,
	b_default = 71,
	b_commentline = 72,
	b_number = 73,
	b_word = 74,
	b_string = 75,
	b_identifier = 76,
	b_stringeol = 77,
	ba_start = 80,
	ba_default = 81,
	ba_commentline = 82,
	ba_number = 83,
	ba_word = 84,
	ba_string = 85,
	ba_identifier = 86,
	ba_stringeol = 87,
	p_start = 90,
	p_default = 91,
	p_commentline = 92,
	p_number = 93,
	p_string = 94,
	p_character = 95,
	p_word = 96,
	p_triple = 97,
	p_tripledouble = 98,
	p_classname = 99,
	p_defname = 100,
	p_operator = 101,
	p_identifier = 102,
	php_complex_variable = 104,
	pa_start = 105,
	pa_default = 106,
	pa_commentline = 107,
	pa_number = 108,
	pa_string = 109,
	pa_character = 110,
	pa_word = 111,
	pa_triple = 112,
	pa_tripledouble = 113,
	pa_classname = 114,
	pa_defname = 115,
	pa_operator = 116,
	pa_identifier = 117,
	php_default = 118,
	php_hstring = 119,
	php_simplestring = 120,
	php_word = 121,
	php_number = 122,
	php_variable = 123,
	php_comment = 124,
	php_commentline = 125,
	php_hstring_variable = 126,
	php_operator = 127,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum Perl
{    
	@default = 0,
	error = 1,
	commentline = 2,
	pod = 3,
	number = 4,
	word = 5,
	@string = 6,
	character = 7,
	punctuation = 8,
	preprocessor = 9,
	@operator = 10,
	identifier = 11,
	scalar = 12,
	array = 13,
	hash = 14,
	symboltable = 15,
	regex = 17,
	regsubst = 18,
	longquote = 19,
	backticks = 20,
	datasection = 21,
	here_delim = 22,
	here_q = 23,
	here_qq = 24,
	here_qx = 25,
	string_q = 26,
	string_qq = 27,
	string_qx = 28,
	string_qr = 29,
	string_qw = 30,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum VB
{    
	@default = 0,
	comment = 1,
	number = 2,
	keyword = 3,
	@string = 4,
	preprocessor = 5,
	@operator = 6,
	identifier = 7,
	date = 8,
	stringeol = 9,
	keyword2 = 10,
	keyword3 = 11,
	keyword4 = 12,
	constant = 13,
	asm = 14,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum VBScript
{    
	@default = 0,
	comment = 1,
	number = 2,
	keyword = 3,
	@string = 4,
	preprocessor = 5,
	@operator = 6,
	identifier = 7,
	date = 8,
	stringeol = 9,
	keyword2 = 10,
	keyword3 = 11,
	keyword4 = 12,
	constant = 13,
	asm = 14,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum PowerBasic
{    
	@default = 0,
	comment = 1,
	number = 2,
	keyword = 3,
	@string = 4,
	preprocessor = 5,
	@operator = 6,
	identifier = 7,
	date = 8,
	stringeol = 9,
	keyword2 = 10,
	keyword3 = 11,
	keyword4 = 12,
	constant = 13,
	asm = 14,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum Properties
{    
	@default = 0,
	comment = 1,
	section = 2,
	assignment = 3,
	defval = 4,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum LaTeX
{    
	@default = 0,
	command = 1,
	tag = 2,
	math = 3,
	comment = 4,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum Lua
{    
	@default = 0,
	comment = 1,
	commentline = 2,
	commentdoc = 3,
	number = 4,
	word = 5,
	@string = 6,
	character = 7,
	literalstring = 8,
	preprocessor = 9,
	@operator = 10,
	identifier = 11,
	stringeol = 12,
	word2 = 13,
	word3 = 14,
	word4 = 15,
	word5 = 16,
	word6 = 17,
	word7 = 18,
	word8 = 19,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum ErrorList
{    
	@default = 0,
	python = 1,
	gcc = 2,
	ms = 3,
	cmd = 4,
	borland = 5,
	perl = 6,
	net = 7,
	lua = 8,
	ctag = 9,
	diff_changed = 10,
	diff_addition = 11,
	diff_deletion = 12,
	diff_message = 13,
	php = 14,
	elf = 15,
	ifc = 16,
	ifort = 17,
	absf = 18,
	tidy = 19,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum Batch
{    
	@default = 0,
	comment = 1,
	word = 2,
	label = 3,
	hide = 4,
	command = 5,
	identifier = 6,
	@operator = 7,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum MakeFile
{    
	@default = 0,
	comment = 1,
	preprocessor = 2,
	identifier = 3,
	@operator = 4,
	target = 5,
	ideol = 9,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum Diff
{    
	@default = 0,
	comment = 1,
	command = 2,
	header = 3,
	position = 4,
	deleted = 5,
	added = 6,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum Conf
{    
	@default = 0,
	comment = 1,
	number = 2,
	identifier = 3,
	extension = 4,
	parameter = 5,
	@string = 6,
	@operator = 7,
	ip = 8,
	directive = 9,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum Avenue
{    
	@default = 0,
	comment = 1,
	number = 2,
	word = 3,
	@string = 6,
	@enum = 7,
	stringeol = 8,
	identifier = 9,
	@operator = 10,
	word1 = 11,
	word2 = 12,
	word3 = 13,
	word4 = 14,
	word5 = 15,
	word6 = 16,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum Ada
{    
	@default = 0,
	word = 1,
	identifier = 2,
	number = 3,
	delimiter = 4,
	character = 5,
	charactereol = 6,
	@string = 7,
	stringeol = 8,
	label = 9,
	commentline = 10,
	illegal = 11,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum Baan
{    
	@default = 0,
	comment = 1,
	commentdoc = 2,
	number = 3,
	word = 4,
	@string = 5,
	preprocessor = 6,
	@operator = 7,
	identifier = 8,
	stringeol = 9,
	word2 = 10,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum Lisp
{    
	@default = 0,
	comment = 1,
	number = 2,
	keyword = 3,
	@string = 6,
	stringeol = 8,
	identifier = 9,
	@operator = 10,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum Eiffel
{    
	@default = 0,
	commentline = 1,
	number = 2,
	word = 3,
	@string = 4,
	character = 5,
	@operator = 6,
	identifier = 7,
	stringeol = 8,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum EiffelKW
{    
	@default = 0,
	commentline = 1,
	number = 2,
	word = 3,
	@string = 4,
	character = 5,
	@operator = 6,
	identifier = 7,
	stringeol = 8,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum NNCronTab
{    
	@default = 0,
	comment = 1,
	task = 2,
	section = 3,
	keyword = 4,
	modifier = 5,
	asterisk = 6,
	number = 7,
	@string = 8,
	environment = 9,
	identifier = 10,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum Forth
{    
	@default = 0,
	comment = 1,
	comment_ml = 2,
	identifier = 3,
	control = 4,
	keyword = 5,
	defword = 6,
	preword1 = 7,
	preword2 = 8,
	number = 9,
	@string = 10,
	locale = 11,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum MatLab
{    
	@default = 0,
	comment = 1,
	command = 2,
	number = 3,
	keyword = 4,
	@string = 5,
	@operator = 6,
	identifier = 7,
	doublequotestring = 8,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum Sol
{    
	@default = 0,
	white = 1,
	commentline = 2,
	persistent = 3,
	cstyle = 4,
	commentblock = 5,
	number = 6,
	@string = 7,
	character = 8,
	stringeol = 9,
	keyword = 10,
	@operator = 11,
	identifier = 12,
	triple = 13,
	classname = 14,
	preprocessor = 15,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum Asm
{    
	@default = 0,
	comment = 1,
	number = 2,
	@string = 3,
	@operator = 4,
	identifier = 5,
	cpuinstruction = 6,
	mathinstruction = 7,
	register = 8,
	directive = 9,
	directiveoperand = 10,
	commentblock = 11,
	character = 12,
	stringeol = 13,
	extinstruction = 14,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum Fortran
{    
	@default = 0,
	comment = 1,
	number = 2,
	string1 = 3,
	string2 = 4,
	stringeol = 5,
	@operator = 6,
	identifier = 7,
	word = 8,
	word2 = 9,
	word3 = 10,
	preprocessor = 11,
	operator2 = 12,
	label = 13,
	continuation = 14,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum F77
{    
	@default = 0,
	comment = 1,
	number = 2,
	string1 = 3,
	string2 = 4,
	stringeol = 5,
	@operator = 6,
	identifier = 7,
	word = 8,
	word2 = 9,
	word3 = 10,
	preprocessor = 11,
	operator2 = 12,
	label = 13,
	continuation = 14,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum CSS
{    
	@default = 0,
	tag = 1,
	@class = 2,
	pseudoclass = 3,
	unknown_pseudoclass = 4,
	@operator = 5,
	identifier = 6,
	unknown_identifier = 7,
	@value = 8,
	comment = 9,
	id = 10,
	important = 11,
	directive = 12,
	doublestring = 13,
	singlestring = 14,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum POV
{    
	@default = 0,
	comment = 1,
	commentline = 2,
	number = 3,
	@operator = 4,
	identifier = 5,
	@string = 6,
	stringeol = 7,
	directive = 8,
	baddirective = 9,
	word2 = 10,
	word3 = 11,
	word4 = 12,
	word5 = 13,
	word6 = 14,
	word7 = 15,
	word8 = 16,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum LOUT
{    
	@default = 0,
	comment = 1,
	number = 2,
	word = 3,
	word2 = 4,
	word3 = 5,
	word4 = 6,
	@string = 7,
	@operator = 8,
	identifier = 9,
	stringeol = 10,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum ESCRIPT
{    
	@default = 0,
	comment = 1,
	commentline = 2,
	commentdoc = 3,
	number = 4,
	word = 5,
	@string = 6,
	@operator = 7,
	identifier = 8,
	brace = 9,
	word2 = 10,
	word3 = 11,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum PS
{    
	@default = 0,
	comment = 1,
	dsc_comment = 2,
	dsc_value = 3,
	number = 4,
	name = 5,
	keyword = 6,
	literal = 7,
	immeval = 8,
	paren_array = 9,
	paren_dict = 10,
	paren_proc = 11,
	text = 12,
	hexstring = 13,
	base85string = 14,
	badstringchar = 15,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum NSIS
{    
	@default = 0,
	comment = 1,
	stringdq = 2,
	stringlq = 3,
	stringrq = 4,
	function = 5,
	variable = 6,
	label = 7,
	userdefined = 8,
	sectiondef = 9,
	subsectiondef = 10,
	ifdefinedef = 11,
	macrodef = 12,
	stringvar = 13,
	number = 14,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum MMIXAL
{    
	leadws = 0,
	comment = 1,
	label = 2,
	opcode = 3,
	opcode_pre = 4,
	opcode_valid = 5,
	opcode_unknown = 6,
	opcode_post = 7,
	operands = 8,
	number = 9,
	@ref = 10,
	@char = 11,
	@string = 12,
	register = 13,
	hex = 14,
	@operator = 15,
	symbol = 16,
	include = 17,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum Clarion
{    
	@default = 0,
	label = 1,
	comment = 2,
	@string = 3,
	user_identifier = 4,
	integer_constant = 5,
	real_constant = 6,
	picture_string = 7,
	keyword = 8,
	compiler_directive = 9,
	builtin_procedures_function = 10,
	structure_data_type = 11,
	attribute = 12,
	standard_equate = 13,
	error = 14,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum LOT
{    
	@default = 0,
	header = 1,
	@break = 2,
	set = 3,
	pass = 4,
	fail = 5,
	abort = 6,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum YAML
{    
	@default = 0,
	comment = 1,
	identifier = 2,
	keyword = 3,
	number = 4,
	reference = 5,
	document = 6,
	text = 7,
	error = 8,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum TeX
{    
	@default = 0,
	special = 1,
	group = 2,
	symbol = 3,
	command = 4,
	text = 5,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum Metapost
{    
	@default = 0,
	special = 1,
	group = 2,
	symbol = 3,
	command = 4,
	text = 5,
	extra = 6,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum Erlang
{    
	@default = 0,
	comment = 1,
	variable = 2,
	number = 3,
	keyword = 4,
	@string = 5,
	@operator = 6,
	atom = 7,
	function_name = 8,
	character = 9,
	macro = 10,
	record = 11,
	separator = 12,
	node_name = 13,
	unknown = 31,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum Octave
{    
	@default = 0,
	comment = 1,
	command = 2,
	number = 3,
	keyword = 4,
	@string = 5,
	@operator = 6,
	identifier = 7,
	doublequotestring = 8,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum MSSQL
{    
	@default = 0,
	comment = 1,
	line_comment = 2,
	number = 3,
	@string = 4,
	@operator = 5,
	identifier = 6,
	variable = 7,
	column_name = 8,
	statement = 9,
	datatype = 10,
	systable = 11,
	global_variable = 12,
	function = 13,
	stored_procedure = 14,
	default_pref_datatype = 15,
	column_name_2 = 16,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum Verilog
{    
	@default = 0,
	comment = 1,
	commentline = 2,
	commentlinebang = 3,
	number = 4,
	word = 5,
	@string = 6,
	word2 = 7,
	word3 = 8,
	preprocessor = 9,
	@operator = 10,
	identifier = 11,
	stringeol = 12,
	user = 19,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum Kix
{    
	@default = 0,
	comment = 1,
	string1 = 2,
	string2 = 3,
	number = 4,
	var = 5,
	macro = 6,
	keyword = 7,
	functions = 8,
	@operator = 9,
	identifier = 31,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum Specman
{    
	@default = 0,
	code = 1,
	commentline = 2,
	commentlinebang = 3,
	number = 4,
	word = 5,
	@string = 6,
	word2 = 7,
	word3 = 8,
	preprocessor = 9,
	@operator = 10,
	identifier = 11,
	stringeol = 12,
	regextag = 13,
	signal = 14,
	user = 19,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum Au3
{    
	@default = 0,
	comment = 1,
	commentblock = 2,
	number = 3,
	function = 4,
	keyword = 5,
	macro = 6,
	@string = 7,
	@operator = 8,
	variable = 9,
	sent = 10,
	preprocessor = 11,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum APDL
{    
	@default = 0,
	comment = 1,
	commentblock = 2,
	number = 3,
	@string = 4,
	word = 5,
	command = 6,
	processor = 7,
	function = 8,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
public enum Bash
{    
	@default = 0,
	error = 1,
	commentline = 2,
	number = 3,
	word = 4,
	@string = 5,
	character = 6,
	@operator = 7,
	identifier = 8,
	scalar = 9,
	param = 10,
	backticks = 11,
	here_delim = 12,
	here_q = 13,
	_default = 32,
	linenumber = 33,
	bracelight = 34,
	bracebad = 35,
	controlchar = 36,
	indentguide = 37,
	lastpredefined = 39,
	max = 127
}
